



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java设计模式之工厂模式（Factory）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java设计模式之工厂模式（Factory）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 23:37:16 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h4>前言：</h4>
<p>前面学习了建造者设计模式，接下来学习一下Retrofit中使用的另外一个设计模式，工厂设计模式！！！里面采用工厂模式使得数据转换得到完全解耦，工厂模式的好处用到了极致，如此好的设计模式我们怎能不学习一下。</p>
<h4>工厂模式：</h4>
<p>工厂模式主要是为创建对象提供过渡接口，以便将创建对象的具体过程屏蔽隔离起来，达到提高灵活性的目的。</p>
<h5>1.）工厂模式分类：</h5>
<ul><li>简单工厂模式（Simple Factory）</li>
<li>工厂方法模式（Factory Method）</li>
<li>抽象工厂模式（Abstract Factory）</li></ul>
<h5>2.）简单工厂模式</h5>
<p>见名知意，简单的工厂模式，建立一个工厂来制造新的对象，又叫静态工厂。举例说明李先生去4s店要买一部轿车， 如何实现？</p>
<p>1. 首先4s签单一部车Car</p>
<div>
<pre class="prettyprint linenums">public class Car {

    public Car() {<br />
        Log.e("car", "Car----&gt;我要买车");<br />
    }

}</pre>
</div>
<p>2.然后4s店通知CarFactory&nbsp;工厂生产</p>
<div>
<pre class="prettyprint linenums">public class CarFactory {

    public static Car createCar() {<br />
        return new Car();<br />
    }

}</pre>
</div>
<p>3.最后按时生产完毕的话将交付给李先生</p>
<div>
<pre class="prettyprint linenums"> Car car = CarFactory.buildCar();</pre>
</div>
<p>整个过程李先生一点不清楚整个轿车的制造过程的情况买到一辆车，通过工厂模式 使得需求和实现解耦。由于工人放假，4s店没有按时交车导致违约，再加上李先生是个多变的人执意退车，而且选择不买轿车了，要买一辆suv，这可急死了销售顾问小王，</p>
<p>接下来小王是怎么留住李先生的呢？</p>
<p>4.销售赶紧通知工厂改造生产线能够支持生产多种车型，涵盖轿车、Suv、Mpv等</p>
<div>
<pre class="prettyprint linenums">public class CarFactory {

    public enum CarType {<br />
        SUV,//多功能越野车<br />
        MPV//多功能商务车<br />
    }

    public static Car createCar() {<br />
        return new Car();<br />
    }

    public static Car createCar(CarType type) {<br />
        Car car = null;<br />
        switch (type) {<br />
            case SUV:<br />
                car = new SuvCar();<br />
                break;<br />
            case MPV:<br />
                car = new MpvCar();<br />
                break;<br />
            default:<br />
                car = new Car();<br />
                break;<br />
        }<br />
        return car;<br />
    }<br />
}</pre>
</div>
<p>SuvCar</p>
<div>
<pre class="prettyprint linenums">public class SuvCar extends Car {

    public SuvCar() {<br />
        Log.e("car", "SuvCar----&gt;Suv");<br />
    }<br />
}</pre>
</div>
<p>MpvCar</p>
<div>
<pre class="prettyprint linenums">public class MpvCar extends Car {

    public MpvCar() {<br />
        Log.e("car", "MpvCar----&gt;Mpv");<br />
    }<br />
}</pre>
</div>
<p>5. 最终4s按时交付了李先生的suv</p>
<div>
<pre class="prettyprint linenums"> Car suvCar = CarFactory.createCar(CarFactory.CarType.SUV);</pre>
</div>
<p>改造工厂之后销售顾问小王的业绩蒸蒸日上，但是好景不长，问题又来了，由于在同一个工厂开发不同的车型导致管理混乱，质量严重不过关，工厂还进行了大量召回和赔偿。接下来公司决定对工厂进行整改。如何整改接下来我们来看<strong>工厂方法模式&nbsp;</strong></p>
<h5><strong>3.）工厂方法模式&nbsp;</strong></h5>
<p><strong>&nbsp; </strong>&nbsp; &nbsp;通过上面的简单工厂模式可以看出，其实简单的工厂模式看似用来简单，但是不利于扩展和维护，稍有不慎就有很大的麻烦，鉴于这个原因我们来看下工厂方法模式，工厂方法为工厂类定义了接口或者抽象类，用多态来分配每个子工厂类的职能，还是接着上面的例子来说明。</p>
<p>1.工厂老板重新定义了公司产品对象就是造车</p>
<div>
<pre class="prettyprint linenums">public interface ICarFactory {

    //造车<br />
    Car createCar();<br />
}</pre>
</div>
<p>2.整理产品线，建造两大整车厂分别生产suv、mpv车型</p>
<pre class="prettyprint linenums">SuvCarFactory </pre>
<div>
<pre class="prettyprint linenums">public class SuvCarFactory implements ICarFactory{<br />
    @Override<br />
    public Car createCar() {<br />
        return new SuvCar();<br />
    }<br />
}</pre>
</div>
<pre class="prettyprint linenums">MpvCarFactory</pre>
<div>
<pre class="prettyprint linenums">public class MpvCarFactory implements ICarFactory{<br />
    @Override<br />
    public Car createCar() {<br />
        return new MpvCar();<br />
    }<br />
}</pre>
</div>
<p>3.这样就可以满足不同的用户</p>
<div>
<pre class="prettyprint linenums">        SuvCarFactory suvCarFactory = new SuvCarFactory();<br />
        Car suvCar = suvCarFactory.createCar();

        MpvCarFactory mpvCarFactory=new MpvCarFactory();<br />
        Car mpvCar=mpvCarFactory.createCar();</pre>
</div>
<h5>4.）<strong>抽象工厂方法</strong></h5>
<p>抽象工厂：意的意图在于创建一系列互相关联或互相依赖的对象，还是接着上面的例子举例说明，由于车市不景气，国家出台了1.6排量及以下的购置税减半，工厂决定一辆suv出两个版本 一个200T一个300T该如何解决呢？这里就用到抽象工厂方法。</p>
<p>1.宣布调整工厂生产产品对象</p>
<div>
<pre class="prettyprint linenums">public interface AbstractCarFactory {

    //制造发送机<br />
    Engine createEngine();

    //造车<br />
    Car createCar();

}</pre>
</div>
<pre class="prettyprint linenums">Engine类</pre>
<div>
<pre class="prettyprint linenums">public class Engine {

    public Engine() {<br />
        Log.e("Engine", "Engine----&gt;我是发送机");<br />
    }<br />
}</pre>
</div>
<pre class="prettyprint linenums">Engine200T类</pre>
<div>
<pre class="prettyprint linenums">public class Engine200T extends Engine {

    public Engine200T(){<br />
        Log.e("Engine", "Engine----&gt;我是200T发动机");<br />
    }<br />
}</pre>
</div>
<pre class="prettyprint linenums">Engine300T类同上</pre>
<p>2.调整产品线以suv200T 、suv300T举例</p>
<div>
<pre class="prettyprint linenums">public class SuvCar200TFactory implements AbstractCarFactory {<br />
    @Override<br />
    public Engine createEngine() {<br />
        return new Engine200T();<br />
    }

    @Override<br />
    public Car createCar() {<br />
        return new SuvCar();<br />
    }<br />
}</pre>
</div>
<p>300T同上不再写</p>
<p>3.产品输出</p>
<div>
<pre class="prettyprint linenums">  SuvCar200TFactory suvCar200TFactory =new SuvCar200TFactory();<br />
        suvCar200TFactory.createEngine();<br />
        suvCar200TFactory.createCar();</pre>
</div>
<p>从举例可以看出工厂方法和工厂抽象的区别在于工厂抽象实现了一系列有关联产品的创建。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kjog69.html">学习设计模式第二十七 - GoF之外简单工厂模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/495wv3z9.html">转：Android开发：使用JNI读取应用签名</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rk3rdq.html">Saas</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnjw5pq.html">&lbrack;leetcode&rsqb;&lowbar;Integer to Roman</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnz12rq.html">&lbrack;译&rsqb;信仰是怎样毁掉程序猿的How religion destroys programmers</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1z45r9.html">Apple-Watch开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1z3m39.html">php基础知识【函数】（9）数学和对象类函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd1l3z8.html">python中print后面加逗号</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm2le49.html">java&period;lang&period;NoClassDefFoundError&colon; org&sol;apache&sol;commons&sol;io&sol;output&sol;DeferredFileOutputStream&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jy7kv8.html">Ztree改版 - 将图标字体化 - fontAwesome</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gexz4z8.html">iKcamp出品微信小程序教学共5章16小节汇总&lpar;含视频&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge0eke8.html">css设置兼容的透明样式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zwz6j9.html">eslint 入门项目搭建过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1pp6xq.html">&lbrack;原创&rsqb;FPGA JTAG工具设计&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllk0peq.html">mysqldump详解之--master-data</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4rg4m9.html">ASP&period;NET MVC下使用AngularJs语言&lpar;九&rpar;：日期时间处理与显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwlred8.html">《算法》第一章部分程序 part 1</a>
		</li>
						<li><a href="https://www.batexi.com/a/953x6pe8.html">scheme的split实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp4kge9.html">MAKEFILE 编程基础之一【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1nr769.html">shell 字符串运算符</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/o8ojey1q.html">调试台自动多出现一个&amp;&num;39&semi;&amp;amp&semi;&num;65279&semi;&amp;&num;39&semi; ，我 用uploadify上传图片时，在给页面写入一个返回值为图片名称的变量的值的时候值的前面始终多出现一个&amp;&num;39&semi;&amp;amp&semi;&num;65279&semi;&amp;&num;39&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8me1e2q.html">Android图书应用-西游记</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxk7pj8.html">JavaScript笔试必备语句【转】</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxkpgz8.html">使用复合设计模式扩展持久化的CURD&comma;Select能力</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy1mk2q.html">Cocopod</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8oj7kpq.html">C&num;常用类笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8megp2q.html">mysql单列去重复group by分组取每组前几条记录加order by排序</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnj30k8.html">TreeSet</a>
			</li>
						<li><a href="https://www.batexi.com/a/390moz48.html">&commat;autowired和&commat;resource的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1kgz09.html">Spring AOP实例&mdash;&mdash;异常处理和记录程序执行时间</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
